console.log("mw_content.js begin");
// Connect native app automatically when page is loaded
//window.onload = connectNativeApp;

// Disconnect native app automatically when page is unloaded
window.onbeforeunload = disconnectNativeApp;

// Connect to Native Messaging Host
function connectNativeApp() {
    var request = new Object();
    request.type = "connect";

    chrome.runtime.sendMessage(request,
        function (response) {
            if (response.success) {
                console.log(response.message);
            } else {
                console.error(response.message);
            }
        });
}

// Disconnect from Native Messaging Host
function disconnectNativeApp() {
    var request = new Object();
    request.type = "disconnect";

    chrome.runtime.sendMessage(request,
        function (response) {
            if (response.success) {
                console.log(response.message);
            } else {
                console.error(response.message);
            }
        });
}

document.addEventListener('ICBC-MW-SendMsg',
	function handleNativeMessage(e) {
		var request = new Object();

		try
		{
			var input = JSON.parse(e.detail);
		}
		catch (e) {
			var response = { success: false, message:"convet to json error" };
			var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': response });
			document.dispatchEvent(event);
			return;
		}
		
		request.type = "message";
		request.message = input;

		try
		{
			chrome.runtime.sendMessage(request,
				function (response) {
					if ( response )
					{
						var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': response });
						document.dispatchEvent(event);
					}
					else
					{
						var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': { success: false, message: "connect error"} });
						document.dispatchEvent(event);
					}
			});
		}
		catch(e) {
			var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': { success: false, message: "connect error"} });
			document.dispatchEvent(event);
		}
	}
, false);

chrome.runtime.onMessage.addListener(function (response) {
	if ( response )
	{
		var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': response });
		document.dispatchEvent(event);
	}
	else
	{
		var event = new CustomEvent('ICBC-MW-GetMsg', { 'detail': { success: false, message: "connect error"} });
		document.dispatchEvent(event);
	}
});

document.addEventListener('ICBC-MW-ExCheck',
	function (e) {
		var request = new Object();
		request.type = "check";

		try
		{
			chrome.runtime.sendMessage(request,
				function (response) {
					if (response && response.success)
					{
						var event = new CustomEvent('isMwExtension', { 'detail': "success" });
						document.dispatchEvent(event);
					}
					else
					{
						var event = new CustomEvent('isMwExtension', { 'detail': "fail" });
						document.dispatchEvent(event);
					}

			});
		}
		catch(e) {
			var event = new CustomEvent('isMwExtension', { 'detail': "fail" });
			document.dispatchEvent(event);
		}
	}
, false); 

document.addEventListener('ICBC-MW-ClearInterval',function(){
	if ( null != timmer )
	{
		clearInterval(timmer);
		timmer = null;
		console.log("Timer Clear!");
	}
});

var g_EventTimeOut = 200;
var g_EventCount = 0;

function noticeFunctionJs(){
	var g_mw_content_event = new CustomEvent('ICBC-MW-Content',{ 'detail': null });
	document.dispatchEvent(g_mw_content_event);
	console.log("Event Create!");
	if ( g_EventTimeOut == g_EventCount )
	{
		if ( null != timmer )
		{
			clearInterval(timmer);
			timmer = null;
			console.log("TimeOut! Timer Clear!");
		}
	}
	g_EventCount++;
}

var timmer = setInterval(noticeFunctionJs,50);
noticeFunctionJs();

console.log("mw_content.js end");